<template>
  <div v-if="pageStatus == 0">配置加载中...</div>
  <div v-else-if="pageStatus == 1">此页面不对此账号开放</div>
  <div v-else-if="pageStatus == 2">没有此页内容的配置权限，请检查集团上的配置</div>
  <div v-else-if="pageStatus == 3">加载发生错误</div>
  <div v-else-if="pageStatus == 4" class="app-container">
    <el-form
      :model="queryForm"
      ref="queryForm"
      :inline="true"
      label-width="88px"
    >
      <el-form-item label="设备类型" prop="deviceType">
        <el-select
          v-model="queryForm.deviceType"
          clearable
          placeholder="请选择"
        >
          <el-option label="小票打印机" value="1"></el-option>
          <el-option label="POS" value="2"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="密钥" prop="deviceSerialNum">
        <el-input
          v-model="queryForm.deviceSerialNum"
          placeholder="请输入设备密钥"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button
          type="cyan"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button
          type="info"
          icon="el-icon-refresh"
          size="mini"
          @click="resetQuery"
          >重置</el-button
        >
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          >新增</el-button
        >
      </el-form-item>
    </el-form>

    <el-table :data="equipmentList">
      <af-table-column
        label="主键自增id"
        v-if="false"
        align="center"
        prop="deviceId"
      />
      <!--
      <af-table-column
        label="油站名称"
        align="center"
        prop="stationName"
        v-if="jiBie !== 2"
      />
      -->
      <af-table-column label="设备类型" align="center" prop="deviceType">
        <template slot-scope="scope">
          {{
            scope.row.deviceType == "1"
              ? "小票打印机"
              : scope.row.deviceType == "2"
              ? "POS"
              : "不明设备"
          }}
        </template>
      </af-table-column>
      <af-table-column label="设备编号" align="center" prop="deviceNo" />
      <af-table-column label="设备密钥" align="center" prop="deviceSerialNum">
        <template slot-scope="scope">
          {{ scope.row.deviceType == "1" ? scope.row.deviceSerialNum : "无" }}
        </template>
      </af-table-column>
      <af-table-column label="绑定油枪号" align="center" prop="gunNo" />
      <af-table-column label="设备厂家" align="center" prop="deviceFactory" />
      <af-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="120px"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            >删除</el-button
          >
        </template>
      </af-table-column>
    </el-table>

    <pagination
      :hidden="total > 0 ? false : true"
      :total="total"
      :page.sync="queryForm.pageNum"
      :limit.sync="queryForm.pageSize"
      @pagination="getList"
      :autoScroll="true"
    />

    <!-- 添加或修改油站设备管理对话框 -->
    <el-dialog
      :title="title"
      :visible.sync="open"
      width="500px"
      append-to-body
      status-icon
    >
      <el-form
        ref="dialogForm"
        :model="dialogForm"
        :rules="rules"
        label-width="100px"
      >
        <el-form-item label="设备类型" prop="deviceType">
          <el-select
            v-model="dialogForm.deviceType"
            placeholder="请选择设备类型"
            clearable
            size="small"
          >
            <el-option label="小票打印机" value="1"></el-option>
            <el-option label="POS" value="2"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="设备名称" prop="deviceName">
          <el-input
            v-model="dialogForm.deviceName"
            placeholder="请输入设备名称"
          />
        </el-form-item>
        <el-form-item label="设备编号" prop="deviceNo">
          <el-input
            v-model="dialogForm.deviceNo"
            placeholder="请输入设备编号"
            @input="deviceNoInput"
          />
        </el-form-item>
        <el-form-item
          label="密钥"
          prop="deviceSerialNum"
          :required="dialogForm.deviceType == 1"
          v-show="dialogForm.deviceType == 1"
        >
          <el-input
            v-model="dialogForm.deviceSerialNum"
            placeholder="请输入设备密钥"
          />
        </el-form-item>
        <el-form-item
          label="交换机名"
          prop="posFanoutExchange"
          :required="dialogForm.deviceType == 2"
          v-show="false"
        >
          <el-input
            v-model="dialogForm.posFanoutExchange"
            placeholder="请输入交换机名"
          />
        </el-form-item>
        <el-form-item
          label="队列名"
          prop="posQueue"
          :required="dialogForm.deviceType==2"
          v-show="false"
        >
          <el-input v-model="dialogForm.posQueue" placeholder="请输入队列名" />
        </el-form-item>
        <el-form-item label="绑定油枪号" prop="checkedGunList" required>
          <template v-if="allGunList.length === 0">
            请先在油枪管理里配置油枪
          </template>
          <template v-else>
            <el-checkbox-group v-model="dialogForm.checkedGunList" v-if="dialogForm.deviceType == 2">
              <el-checkbox
                v-for="item in posList"
                :key="item.oilGunId"
                :label="item.oilGunNo"
                :value="item.oilGunNo"
              >
                {{ item.oilGunNo + "号枪/" + item.oilName }}
              </el-checkbox>
            </el-checkbox-group>
            <el-checkbox-group v-model="dialogForm.checkedGunList" v-if="dialogForm.deviceType == 1">
              <el-checkbox
                v-for="item in printList"
                :key="item.oilGunId"
                :label="item.oilGunNo"
                :value="item.oilGunNo"
              >
                {{ item.oilGunNo + "号枪/" + item.oilName }}
              </el-checkbox>
            </el-checkbox-group>
          </template>
        </el-form-item>
        <el-form-item label="设备厂家" prop="deviceFactory">
          <el-input
            v-model="dialogForm.deviceFactory"
            placeholder="请输入设备厂家"
          />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listManage,
  getManage,
  delManage,
  addManage,
  updateManage,
  exportManage,
  changeManageStatus,
} from "@/api/station/manage";
import { listGun } from "@/api/station/gun";
export default {
  name: "Station_Equipment",
  data() {
    let validateGunNo = (rule, value, callback) => {
      if (this.allGunList.length === 0) {
        callback(new Error("请先配置油枪后再来配置设备"));
        return;
      }
      if (this.dialogForm.checkedGunList.length === 0) {
        callback(new Error("请勾选要绑定的油枪"));
        return;
      }
      callback();
    };
    return {
      pageStatus: 0,
      // 油站设备管理表格数据
      equipmentList: [],
      // 油枪复选
      allGunList: [],
      // 已选的油枪
      checkedGunList: [],
      //设备状态
      deviceStatusOptions: [],
      //设备类型
      deviceTypeOptions: [],
      stationOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 总条数
      total: 100,
      // 查询参数
      queryForm: {
        pageNum: 1,
        pageSize: 10, // 初始值只能比10大
        deviceNo: null,
        deviceSerialNum: null, // 设备密钥
      },
      // 弹窗表单参数
      dialogForm: {
        checkedGunList: [],
        deviceStatus: "1",
        deviceType: "1",
      },
      currentList: [],
      // 表单校验
      rules: {
        deviceNo: [
          { required: true, message: "请输入设备编号", trigger: "blur" },
        ],
        deviceName: [
          { required: true, message: "请输入设备名", trigger: "blur" },
        ],
        // deviceSerialNum: [
        //   { required: true, message: "请输入设备密钥", trigger: "blur" },
        // ],
        deviceType: [
          { required: true, message: "请选择设备类型", trigger: "blur" },
        ],
        checkedGunList: [{ validator: validateGunNo, trigger: "change" }],
        deviceStatus: [
          { required: true, message: "请选择设备状态", trigger: "blur" },
        ],
        deviceFactory: [
          // { required: true, message: '请输入设备厂家', trigger: 'blur' }
        ],
      },
    };
  },
  created() {
    this.init();
    this.setPageStatus()
  },
  computed: {
    posList() {
      const temp = this.allGunList.filter((item) => {
        let flag = false;
        this.equipmentList.map((ele) => {
          if (ele.deviceType == 2) {
            if (ele.gunNo.split(",").includes(item.oilGunNo)) {
              flag = true;
              return;
            }
          }
        });
        return flag;
      });
      const temp2 = this.allGunList.filter((item) => {
        let flag = true;
        temp.map((ele) => {
          if (item.oilGunNo == ele.oilGunNo) {
            flag = false;
          }
        });
        return flag;
      });
      return this.currentList.concat(temp2)
    },
    printList() {
      const temp = this.allGunList.filter((item) => {
        let flag = false;
        this.equipmentList.map((ele) => {
          if (ele.deviceType == 1) {
            if (ele.gunNo.split(",").includes(item.oilGunNo)) {
              flag = true;
              return;
            }
          }
        });
        return flag;
      });
      const temp2 = this.allGunList.filter((item) => {
        let flag = true;
        temp.map((ele) => {
          if (item.oilGunNo == ele.oilGunNo) {
            flag = false;
          }
        });
        return flag;
      });
      return this.currentList.concat(temp2)
    },
  },
  methods: {
    init() {
      this.getList();
      //字典设备状态
      this.getDicts("device_status").then((response) => {
        this.deviceStatusOptions = response.data;
      });
      //字典设备类型
      this.getDicts("device_type").then((response) => {
        this.deviceTypeOptions = response.data;
      });
      listGun({
        stationId: this.deptId,
      }).then((response) => {
        this.allGunList = response.rows;
      });
    },
    setPageStatus() {
      this.queryPageStatus([2]).then((res) => {
        this.pageStatus = res;
      });
    },
    /** 查询油站设备管理列表 首页表单 */
    getList() {
      listManage(this.queryForm).then((response) => {
        this.equipmentList = response.rows;
        this.total = response.total;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryForm.pageNum = 1;
      this.getList();
    },
    deviceNoInput(value) {
      this.dialogForm.posQueue = value;
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.currentList = [];
      this.title = "添加油站设备管理";
      this.dialogForm = {
        checkedGunList: [],
        deviceStatus: "1",
        deviceType: "1",
        posFanoutExchange: "posFanoutExchange" + this.deptId,
      };
      this.open = true;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.currentList = this.allGunList.filter((ele)=>{
        return row.gunNo.split(",").includes(ele.oilGunNo)
      })
      let checkedGunList;
      if (Object.prototype.toString.call(row.gunNo) === "[object String]") {
        checkedGunList = [...new Set(row.gunNo.split(","))].filter((ele) => {
          return ele.toString().trim() !== "";
        });
      } else {
        checkedGunList = [];
      }
      this.dialogForm = { ...row, checkedGunList };
      this.title = "修改油站设备管理";
      this.open = true;
    },

    /** 提交按钮 */
    submitForm() {
      this.$refs["dialogForm"].validate((valid) => {
        if (valid) {
          this.dialogForm.gunNo = this.dialogForm.checkedGunList.toString();
          if (this.dialogForm.deviceId != null) {
            updateManage(this.dialogForm).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addManage(this.dialogForm).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const deviceIds = row.deviceId;
      this.$confirm("是否确认删除油站设备管理", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delManage(deviceIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        });
    },
    /** 导出按钮操作 */
    // handleExport() {
    //   const queryForm = this.queryForm;
    //   this.$confirm("是否确认导出所有油站设备管理数据项?", "警告", {
    //     confirmButtonText: "确定",
    //     cancelButtonText: "取消",
    //     type: "warning",
    //   })
    //     .then(function () {
    //       return exportManage(queryForm);
    //     })
    //     .then((response) => {
    //       this.download(response.msg);
    //     });
    // },
  },
};
</script>
